<?php
/*
Plugin Name: PR Checker
Plugin URI: http://www.stratos.me/wp-plugins/pr-checker/
Description: This plugin keeps and updates PR and other stuff about URL's
Author: Stratos Geroulis
Version: 1.1
Author URI: http://www.stratos.me
*/

/*
Copyright (C) 2009  Geroulis Efstratios
Contact me at: stratosg@stratosector.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

//PAGE

function prchecker_style(){
	$style = '<style type="text/css">
				div.prchecker_data th {
					background-color: #44f;
					padding: 5px 0;
				}
				div.prchecker_data td {
					padding: 5px 0;
				}
				div.prchecker_data tr.one {
					background-color: #aaf;
				}
				div.prchecker_data tr.two {
					background-color: #ccf;
				}
				div.prchecker_data a {
					color: #000;
				}
			  </style>';
	echo $style;
}

function prchecker_replace($data){
	global $wpdb;
	
	$sort = array('pr', 'alexa', 'technorati', 'feedburner');
	$sort_dir = 'desc';
	
	if(isset($_GET['sort'])){
		switch($_GET['sort']){
			case 1:
				$sort = array('pr', 'alexa', 'technorati', 'feedburner');
				$sort_dir = 'DESC';
			break;
			case 2:
				$sort = array('alexa', 'pr', 'technorati', 'feedburner');
				$sort_dir = 'ASC';
			break;
			case 3:
				$sort = array('technorati', 'pr', 'alexa', 'feedburner');
				$sort_dir = 'ASC';
			break;
			case 4:
				$sort = array('feedburner', 'pr', 'alexa', 'technorati');
				$sort_dir = 'DESC';
			break;
		}
	}
	
	$results = $wpdb->get_results($wpdb->prepare('SELECT url, pr, alexa, technorati, feedburner, follow FROM '.$wpdb->prefix.'prc_urls ORDER BY '.$sort[0].' '.$sort_dir.', '.$sort[1].' ASC, '.$sort[2].' ASC, '.$sort[3].' DESC;'));
	
	$output = '<div class="prchecker_data">
				<table width="100%" cellpadding=0 cellspacing=0>
				<tr>
					<th valign="middle">URL</th>
					<th align="center" valign="middle">
						<a href="'.prchecker_uri_builder(1).'"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/google.jpg" /></a>
					</th>
					<th align="center" valign="middle">
						<a href="'.prchecker_uri_builder(2).'"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/alexa.jpg" /></a>
					</th>
					<th align="center" valign="middle">
						<a href="'.prchecker_uri_builder(3).'"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/technorati.jpg" /></a>
					</th>
					<th align="center" valign="middle">
						<a href="'.prchecker_uri_builder(4).'"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/feedburner.jpg" /></a>
					</th>
				</tr>';
	$i=0;
	foreach($results as $result){
		$output .= '<tr class="'.($i % 2 == 0 ? 'one' : 'two').'">
						<td><a href="'.$result->url.'" rel="'.($result->follow == 'yes' ? 'follow' : 'nofollow').'">'.$result->url.'</a></td>
						<td>'.$result->pr.'</td>
						<td>'.$result->alexa.'</td>
						<td>'.$result->technorati.'</td>
						<td>'.$result->feedburner.'</td>
					</tr>';
		$i++;
	}
	$output .= '</table></div>';
	
	return str_replace('[#prchecker#]', $output, $data);
}

function prchecker_uri_builder($sort){
	$uri = $_SERVER['REQUEST_URL'].'?';
	$gets = array_keys($_GET);
	
	foreach($gets as $get){
		if($get != 'sort'){
			$uri.= $get.'='.$_GET[$get].'&';
		}
	}
	
	$uri .= 'sort='.$sort;
	
	return $uri;
}

add_filter('the_content', 'prchecker_replace', 1, 1);
add_action('wp_head', 'prchecker_style');

//ADMIN
add_action('admin_menu', 'prchecker_plugin_menu');

function prchecker_plugin_menu() {
	add_options_page('PR Checker', 'PR Checker', 8, __FILE__, 'prchecker_admin_page');
}

function prchecker_admin_page() {
	global $wpdb;
	
	$text = '<h2>URL\'s</h2>';
	$technorati_key = get_option('prchecker_technorati_key');
	
	if($technorati_key == ''){
		$text .= '<div id="message" class="error fade below-h2">Your Technorati key is missing! You need one for the Technorati ranking to work!</div>';
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'add'){
		$wpdb->show_errors();
		if(isset($_POST['edit_url'])){//editing
			$wpdb->query($wpdb->prepare('UPDATE '.$wpdb->prefix.'prc_urls SET url = "%s", feedburner_id = "%s", follow = "%s" WHERE url = "%s";', $_POST['pr_url'], $_POST['fb_id'], $_POST['pr_dofollow'], $_POST['edit_url']));
		}
		else{
			$urls = $wpdb->get_results($wpdb->prepare('SELECT url FROM '.$wpdb->prefix.'prc_urls WHERE url="'.$_POST['pr_url'].'";'));
			if(count($urls) > 0){
				$text .= '<div id="message" class="error fade below-h2">This URL already exists!</div>';
			}
			else{
				$query = 'INSERT INTO '.$wpdb->prefix.'prc_urls (url, feedburner_id, follow) VALUES (%s, %s, %s);';
				$wpdb->query($wpdb->prepare($query , $_POST['pr_url'], $_POST['fb_id'], $_POST['pr_dofollow']));
			}
		}
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'delete'){
		$wpdb->show_errors();
		$query = 'DELETE FROM '.$wpdb->prefix.'prc_urls WHERE url="%s";';
		$wpdb->query($wpdb->prepare($query , $_GET['u']));
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'update_url'){
		$wpdb->show_errors();
		$urls = $wpdb->get_results($wpdb->prepare('SELECT url, feedburner_id FROM '.$wpdb->prefix.'prc_urls WHERE url = "'.$_GET['u'].'";'));
		if(count($urls) == 0){
			$text .= '<div id="message" class="error fade below-h2">There is something wrong with the URL!</div>';
		}
		else{
			$url = $urls[0];
			$rankings = array($url->url, prchecker_getpagerank($url->url), prchecker_get_technorati_rank($url->url, $technorati_key), prchecker_get_alexa_popularity($url->url), ($url->feedburner_id != '' ? prchecker_get_feedburner_count($url->feedburner_id) : 0));
			$query = 'UPDATE '.$wpdb->prefix.'prc_urls SET pr = "%s", technorati = "%s", alexa = "%s", feedburner = "%s" WHERE url="%s";';
			$wpdb->query($wpdb->prepare($query, $rankings[1], $rankings[2], $rankings[3], $rankings[4], $rankings[0]));
		}
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'update'){
		$urls = $wpdb->get_results('SELECT url, feedburner_id FROM '.$wpdb->prefix.'prc_urls;');
		$url_data = array();
		foreach($urls as $url){
			$url_data[] = array($url->url, prchecker_getpagerank($url->url), prchecker_get_technorati_rank($url->url, $technorati_key), prchecker_get_alexa_popularity($url->url), ($url->feedburner_id != '' ? prchecker_get_feedburner_count($url->feedburner_id) : 0));
		}
		foreach($url_data as $url){
			$query = 'UPDATE '.$wpdb->prefix.'prc_urls SET pr = "%s", technorati = "%s", alexa = "%s", feedburner = "%s" WHERE url="%s";';
			$wpdb->query($wpdb->prepare($query, $url[1], $url[2], $url[3], $url[4], $url[0]));
		}
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'tckey'){
		if(get_option('prchecker_technorati_key') == ''){//needs adding
			add_option('prchecker_technorati_key', $_POST['technorati_key']);
		}
		else{
			update_option('prchecker_technorati_key', $_POST['technorati_key']);
		}
		$technorati_key = get_option('prchecker_technorati_key');
	}
	
	if(isset($_GET['op']) && $_GET['op'] == 'edit'){
		$urls = $wpdb->get_results($wpdb->prepare('SELECT url, feedburner_id, follow FROM '.$wpdb->prefix.'prc_urls WHERE url = "'.$_GET['u'].'";'));
		if(count($urls) == 0){
			$text .= '<div id="message" class="error fade below-h2">There is some kind of problem with the URL!</div>';
		}
		else{
			$edit_data = array($urls[0]->url, $urls[0]->feedburner_id, $urls[0]->follow);
		}
	}
	
	$urls = $wpdb->get_results('SELECT url, pr, alexa, technorati, feedburner, follow FROM '.$wpdb->prefix.'prc_urls ORDER BY pr DESC, alexa ASC, technorati ASC;');
	
	prchecker_style();
	$text .= '<div class="prchecker_data" id="prchecker_data">
			  <table width="100%" celpadding=0 cellspacing=0>
				<tr>
					<th>URL</th>
					<th align="center"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/google.jpg" /></th>
					<th align="center"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/alexa.jpg" /></th>
					<th align="center"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/technorati.jpg" /></th>
					<th align="center"><img alt="pr" src="'.get_bloginfo('wpurl').'/wp-content/plugins/pr-checker/images/feedburner.jpg" /></th>
					<th align="center">Follow</th>
					<th></th>
				</tr>';
	$i=0;
	foreach($urls as $url){
		$text .= '<tr class="'.($i % 2 == 0 ? 'one' : 'two' ).'">
					<td>'.$url->url.'</td>
					<td align="center">'.$url->pr.'</td>
					<td align="center">'.$url->alexa.'</td>
					<td align="center">'.$url->technorati.'</td>
					<td align="center">'.$url->feedburner.'</td>
					<td align="center">'.($url->follow == 'yes' ? 'Yes' : 'No').'</td>
					<td align="center">
						<a class="button rbutton" href="?page=pr-checker/pr_checker.php&amp;op=delete&amp;u='.$url->url.'">Delete</a>
						<a class="button rbutton" href="?page=pr-checker/pr_checker.php&amp;op=update_url&amp;u='.$url->url.'">Update</a>
						<a class="button rbutton" href="?page=pr-checker/pr_checker.php&amp;op=edit&amp;u='.$url->url.'">Edit</a>
					</td>
				  </tr>';
		$i++;
	}
	$text .= '</table></div>
			  <br />
			  <a href="?page=pr-checker/pr_checker.php&amp;op=update" class="button rbutton">Update All</a>
			  <h2>'.(isset($edit_data) ? 'Edit URL' : 'Add URL').'</h2>
				The FeedBurner ID is the bold part of the feed here: http://feeds2.feedburner.com/<b>thoushallblog</b>
				<br>
				<br>
			  <form name="pr_add" action="?page=pr-checker/pr_checker.php&amp;op=add" method="post">
				URL&nbsp;<input type="text" value="'.(isset($edit_data) ? $edit_data[0] : 'http://').'" name="pr_url" />
				<br />
				FeedBurner ID&nbsp;<input type="text" name="fb_id" value="'.(isset($edit_data) ? $edit_data[1] : '').'">
				<br />
				DoFollow
				&nbsp;Yes<input type="radio" name="pr_dofollow" value="yes" '.((isset($edit_data) && $edit_data[2] == 'yes') ? 'checked' : '').'>
				&nbsp;No<input type="radio" name="pr_dofollow" value="no" '.((isset($edit_data) && $edit_data[2] == 'no') ? 'checked' : '').'>
				<input type="submit" value="'.(isset($edit_data) ? 'Save' : 'Add').'" />
				'.(isset($edit_data) ? '<input type="hidden" value="'.$edit_data[0].'" name="edit_url">' : '').'
			  </form>
			  <h2>Technorati Key</h2>
			  If you don\'t have one, you can get one for free <a href="http://technorati.com/developers/api/" target="_blank">here</a>.
			  <br>
			  <br>
			  <form name="technorati_key_add" action="?page=pr-checker/pr_checker.php&amp;op=tckey" method="post">
				Technorati Key&nbsp;<input type="text" value="'.$technorati_key.'" name="technorati_key">&nbsp;<input type="submit" value="Save">
			  </form>
			  <br />
			  <br />
			  <div style="border: 1px solid #000; background: #EAFB78;">
				If you like this plugin please consider donating. I know i could be making easy money by <strong>making</strong> you buying but
				i don\'t want to do it. I am a great supporter of opensource and freeware / thankware stuff. So, if you really use this plugin
				and it saves you a lot of trouble why not donate something to me as a token of appreciation. Any amount is welcome!
				<center>
					<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
					<input type="hidden" name="cmd" value="_s-xclick">
					<input type="hidden" name="hosted_button_id" value="4931378">
					<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
					<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
					</form>
				</center>
			  </div>
			  ';
	
	echo $text;
}


//REGISTRATION
function pr_checker_db_create() {
	global $wpdb;

	$query = 'CREATE TABLE '.$wpdb->prefix.'prc_urls (
				url varchar(255) not null,
				pr int(1) not null default 0,
				alexa int(8) not null default 99999999,
				technorati int(8) not null default 99999999,
				feedburner int(8) not null default 0,
				feedburner_id varchar(255) not null default "",
				follow enum("yes", "no") default "yes",
				UNIQUE KEY url (url)
			 );';

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($query);

}

function pr_checker_db_destroy() {
	global $wpdb;
	$query = 'DROP TABLE '.$wpdb->prefix.'prc_urls';
	$wpdb->query($query);
}

register_activation_hook(__FILE__, 'pr_checker_db_create');
register_deactivation_hook(__FILE__, 'pr_checker_db_destroy');

//RETRIEVERS
//--> for google pagerank 
function prchecker_StrToNum($Str, $Check, $Magic) 
{ 
    $Int32Unit = 4294967296;  // 2^32 

    $length = strlen($Str); 
    for ($i = 0; $i < $length; $i++) { 
        $Check *= $Magic;      
        //If the float is beyond the boundaries of integer (usually +/- 2.15e+9 = 2^31), 
        //  the result of converting to integer is undefined 
        //  refer to http://www.php.net/manual/en/language.types.integer.php 
        if ($Check >= $Int32Unit) { 
            $Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit)); 
            //if the check less than -2^31 
            $Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check; 
        } 
        $Check += ord($Str{$i}); 
    } 
    return $Check; 
} 

//--> for google pagerank 
/* 
* Genearate a hash for a url 
*/ 
function prchecker_HashURL($String) 
{ 
    $Check1 = prchecker_StrToNum($String, 0x1505, 0x21); 
    $Check2 = prchecker_StrToNum($String, 0, 0x1003F); 

    $Check1 >>= 2;      
    $Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F); 
    $Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF); 
    $Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);    
    
    $T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F ); 
    $T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 ); 
    
    return ($T1 | $T2); 
} 

//--> for google pagerank 
/* 
* genearate a checksum for the hash string 
*/ 
function prchecker_CheckHash($Hashnum) 
{ 
    $CheckByte = 0; 
    $Flag = 0; 

    $HashStr = sprintf('%u', $Hashnum) ; 
    $length = strlen($HashStr); 
    
    for ($i = $length - 1;  $i >= 0;  $i --) { 
        $Re = $HashStr{$i}; 
        if (1 === ($Flag % 2)) {              
            $Re += $Re;      
            $Re = (int)($Re / 10) + ($Re % 10); 
        } 
        $CheckByte += $Re; 
        $Flag ++;    
    } 

    $CheckByte %= 10; 
    if (0 !== $CheckByte) { 
        $CheckByte = 10 - $CheckByte; 
        if (1 === ($Flag % 2) ) { 
            if (1 === ($CheckByte % 2)) { 
                $CheckByte += 9; 
            } 
            $CheckByte >>= 1; 
        } 
    } 

    return '7'.$CheckByte.$HashStr; 
} 

//get google pagerank 
function prchecker_getpagerank($url) { 
    $query="http://toolbarqueries.google.com/search?client=navclient-auto&ch=".prchecker_CheckHash(prchecker_HashURL($url)). "&features=Rank&q=info:".$url."&num=100&filter=0"; 
    $data=file_get_contents($query); 
    $pos = strpos($data, "Rank_"); 
    if($pos === false){} else{ 
        $pagerank = substr($data, $pos + 9); 
        return $pagerank; 
    } 
} 


//get technorati rank 
function prchecker_get_technorati_rank($url, $apikey) 
{ 
    global $techno_url, $techno_inblogs, $techno_inlinks, $techno_update;
	
	if($apikey == ''){
		return '99999999';
	}
    
    $technorati_xml = "http://api.technorati.com/bloginfo?key=" . $apikey . "&url=" . $url; 
    $xml_parser = xml_parser_create(); 
    
    $fp = fopen($technorati_xml, "r") or die("Error: Reading XML data."); 
    $data = ""; 
    while (!feof($fp)) { 
        $data .= fread($fp, 8192); 
    } 
    fclose($fp); 
    
    $data=file_get_contents($technorati_xml); 
    xml_parse_into_struct($xml_parser, $data, $vals, $index); 
    xml_parser_free($xml_parser); 
    
    //get values 
    $index_rank = $index['RANK'][0]; 
    $techno_rank = $vals[$index_rank]['value']; 
    
    $index_inblogs = $index['INBOUNDBLOGS'][0]; 
    $techno_inblogs = number_format(trim($vals[$index_inblogs]['value'])); 
    $index_inlinks = $index['INBOUNDLINKS'][0]; 
    $techno_inlinks = number_format(trim($vals[$index_inlinks]['value'])); 
    $index_update = $index['LASTUPDATE'][0]; 
    $techno_update = trim($vals[$index_update]['value']); 

    
    return $techno_rank; 
} 

//get alexa popularity 
function prchecker_get_alexa_popularity($url) 
{    
global $alexa_backlink, $alexa_reach; 
    $alexaxml = "http://xml.alexa.com/data?cli=10&dat=nsa&url=".$url; 
    
    $xml_parser = xml_parser_create(); 
    
    $fp = fopen($alexaxml, "r") or die("Error: Reading XML data."); 
    $data = ""; 
    while (!feof($fp)) { 
        $data .= fread($fp, 8192); 
        } 
    fclose($fp); 
    
    $data=file_get_contents($alexaxml); 
    xml_parse_into_struct($xml_parser, $data, $vals, $index); 
    xml_parser_free($xml_parser); 
    
    
    $index_popularity = $index['POPULARITY'][0]; 
    $index_reach = $index['REACH'][0]; 
    $index_linksin = $index['LINKSIN'][0]; 
    $alexarank = $vals[$index_popularity]['attributes']['TEXT']; 
    $alexa_backlink = $vals[$index_linksin]['attributes']['NUM']; 
    $alexa_reach = $vals[$index_reach]['attributes']['RANK']; 
    
    return $alexarank; 
}

function prchecker_get_feedburner_count($url)
{
	//open connection
	$ch = curl_init();

	//set the url, number of POST vars, POST data
	curl_setopt($ch,CURLOPT_URL,'https://feedburner.google.com/api/awareness/1.0/GetFeedData?uri='.$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);  
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);

	//execute post
	$content = curl_exec($ch);
	
	preg_match('/circulation="(.*)"/isU',$content,$matches);
	$subscribers = $matches[1];

	//close connection
	curl_close($ch);
	
	return $subscribers;
}

?>
